<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//

define("VIEWINIFILE_INIT", "[Init]");
define("VIEWINIFILE_REAR_VIEW", "[Rear-View]");
define("VIEWINIFILE_FRONT_VIEW", "[Front-View]");
define("VIEWINIFILE_TOP_VIEW", "[Top-View]");
define("VIEWINIFILE_REAR_VIEW_IMAGEMAP", "[Rear-View-Imagemap]");
define("VIEWINIFILE_FRONT_VIEW_IMAGEMAP", "[Front-View-Imagemap]");
define("VIEWINIFILE_TOP_VIEW_IMAGEMAP", "[Top-View-Imagemap]");
define("VIEWINIFILE_INFO_TITLE", "[Info-Title]");
define("VIEWINIFILE_INFO_OID_STRING", "[Info-OID-String]");
define("VIEWINIFILE_COMPOSITE_INFO_IMAGE", "[Composite-Info-Image]");
define("VIEWINIFILE_OID_REFRESH", "[OID-Refresh]");
define("VIEWINIFILE_VIEW_ALARM", "[View-Alarm]");
define("VIEWINIFILE_VIEW_ALARM_INFO", "[View-Alarm-Info]");
define("VIEWINIFILE_INFO_ALARM", "[Info-Alarm]");
define("VIEWINIFILE_INFO_ALARM_ANIMATION", "[Info-Alarm-Animation]");
define("VIEWINIFILE_RT_CHART", "[RT-Chart]");
define("VIEWINIFILE_STATIC_VALUE", "[Static-Value]");
define("VIEWINIFILE_PLATFORM_IMAGES", "[Platform-Images]");
define("VIEWINIFILE_PLATFORM_IMAGES_ALARM", "[Platform-Images-Alarm]");
define("VIEWINIFILE_PLATFORM_IMAGES_ALARM_ANIMATION", "[Platform-Images-Alarm-Animation]");

define("VIEWINIFILE_MODIFY_SECONDARY_OID_SEQUENCE", "[Modify-Secondary-OID-Sequence]");

define("OID_SEQ_MODIFY_ACTION_MOVE_TO_TAIL", "MT");

define("VIEW_QRYSTR_FRONT", "front");
define("VIEW_QRYSTR_REAR", "rear");
define("VIEW_QRYSTR_TOP", "top");

define("VIEWINI_VWIDX_TITLE", "title");
define("VIEWINI_VWIDX_IMAGE", "image");
define("VIEWINI_VWIDX_IMAGE_COMPOSITE", "image-composite");
define("VIEWINI_VWIDX_INITINFO", "initinfo");
define("VIEWINI_VWIDX_UPLINK", "uplink");
define("VIEWINI_VWIDX_DOWNLINK", "downlink");
define("VIEWINI_VWIDX_LEFTLINK", "leftlink");
define("VIEWINI_VWIDX_RIGHTLINK", "rightlink");
define("VIEWINI_VWIDX_USEMAP", "usemap");
define("VIEWINI_VWIDX_INFOOIDS", "infooids");
define("VIEWINI_VWIDX_INFOSTRINGS", "infostrings");

define("VIEW_INFO_TYPE_OID", "O");
define("VIEW_INFO_TYPE_STRING", "S");

function _viewini_ ($view_settings, $var_index, $snmp_source_ip_address, $snmp_source_community)
{
    if (!strcmp($var_index, VIEWINI_VWIDX_IMAGE) || !strcmp($var_index, VIEWINI_VWIDX_INITINFO)) {
        $value = $view_settings[$var_index];
        if (!strcmp($var_index, VIEWINI_VWIDX_IMAGE)) {
            if (!strcmp($value, "-")) {
                $value = $view_settings[VIEWINI_VWIDX_IMAGE_COMPOSITE];
                list($ckoid, $ifexs, $ifnexs) = explode(',', $value);
                list($entry_oid, $value_type, $exs_value) = explode('!', $ckoid);
                $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $entry_oid, $value_type);
                if (check_oid_exist($exs_value, $acq)) {
                    list($imageurl, $width, $height) = explode('!', $ifexs);
                } else {
                    list($imageurl, $width, $height) = explode('!', $ifnexs);
                }
            } else
                list($imageurl, $width, $height) = explode(',', $value);
        } else
            list($imageurl, $width, $height) = explode(',', $value);
            
        if (strcmp($imageurl, "-")) {
            $ret = "<img src=\"$imageurl\" border=\"0\" width=\"$width\" height=\"$height\"";
            if (!strcmp($var_index, VIEWINI_VWIDX_IMAGE)) {
                $usemap = $view_settings[VIEWINI_VWIDX_USEMAP];
                if (!strcmp($usemap, "1")) {
                    $ret = "{$ret}  usemap=\"#MyMap\"";
                }
            }
            $ret = "{$ret}>";
            return $ret;
        }
        return "&nbsp;";
    }
    if (!strcmp($var_index, VIEWINI_VWIDX_UPLINK) || !strcmp($var_index, VIEWINI_VWIDX_DOWNLINK) ||
        !strcmp($var_index, VIEWINI_VWIDX_LEFTLINK) || !strcmp($var_index, VIEWINI_VWIDX_RIGHTLINK)) {
        $value = $view_settings[$var_index];
        list($imageurl, $width, $height, $querystring, $altmsg) = explode(',', $value);
        if (strcmp($querystring, "-"))
            return "<a href=\"summleft.php?n=1&v=$querystring\"><img name=\"$var_index\" src=\"$imageurl\" border=\"0\" width=\"$width\" height=\"$height\" alt=\"$altmsg\"></a>";
        return "<img name=\"$var_index\" src=\"$imageurl\" border=\"0\" width=\"$width\" height=\"$height\" alt=\"\">";
    }

    return "&nbsp;";
}

function _gen_alarm_vars_ ($view_alarm, $vars)
{
    $dummy = ALARM_NORMAL;
    if (!empty($view_alarm)) {
        foreach ($view_alarm as $alarm_pair => $pos) {
            list($alarm, $alarm_type) = explode(',', $alarm_pair);
            if (!strcmp($alarm_type, "C")) {
                if (!in_array($alarm, $vars))
                    $vars[] = $alarm;
            }
        }
    }
    return $vars;
}
?>