<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
    usleep(750000);
    include("___defines___.php");

    if (session_is_registered('snmp_source_ip_address')) {
        $snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
        $snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];
        $system_if_ipaddress_walkoid = $HTTP_SESSION_VARS['system_if_ipaddress_walkoid'];
        $ipaddress = acquire_multiple_values($snmp_source_ip_address, $snmp_source_community, $system_if_ipaddress_walkoid);
        remove_value(&$ipaddress, '0.0.0.0');
        remove_value(&$ipaddress, '127.0.0.1');
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html>
<head>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
<title>ASUS System Web-base Management (<?php echo implode(',', $ipaddress);?>)</title></head>
<?php

        $snmp_entry_name = $HTTP_SESSION_VARS["snmp_entry_name"];
        $snmp_entry_value_type = $HTTP_SESSION_VARS["snmp_entry_value_type"];
        $snmp_entry_attribute = $HTTP_SESSION_VARS["snmp_entry_attribute"];
        $snmp_entry_alarm = $HTTP_SESSION_VARS["snmp_entry_alarm"];
        $snmp_entry_value_translation = $HTTP_SESSION_VARS["snmp_entry_value_translation"];

        if (!empty($snmp_entry_value_type))
            foreach ($snmp_entry_value_type as $entry_oid => $value_type) {
                $attribute = $snmp_entry_attribute[$entry_oid];
                $entry_name = $snmp_entry_name[$entry_oid];
                $translation = $snmp_entry_value_translation[$entry_oid];
                if (!strcmp($attribute, OID_ATTR_INFO) || !strcmp($attribute, OID_ATTR_WATCH) || !strcmp($attribute, OID_ATTR_WATCHX) || !strcmp($attribute, OID_ATTR_WATCHRAID) ||
                    !strcmp($attribute, OID_ATTR_SWITCH) ||
                    !strcmp($attribute, OID_ATTR_HLIMIT) || !strcmp($attribute, OID_ATTR_LLIMIT) ||
                    !strcmp($attribute, OID_ATTR_WHLIMIT) || !strcmp($attribute, OID_ATTR_WLLIMIT)) {
                    if (!strcmp($attribute, OID_ATTR_HLIMIT) || !strcmp($attribute, OID_ATTR_LLIMIT) ||
                        !strcmp($attribute, OID_ATTR_WHLIMIT) || !strcmp($attribute, OID_ATTR_WLLIMIT)) {
                        $acq = '0';
                    } else
                        $acq = acquire_single_value($snmp_source_ip_address, $snmp_source_community, $entry_oid, $value_type);
                    if (!strcmp($attribute, OID_ATTR_WATCHRAID)) {
                        list($nrdisk, $actdisk, $workdisk, $faildisk, $sparedisk, $resync, $recovery) = explode(':', ereg_replace('^\"(.*)\"$', '\\1', $acq));
                        $vars[] = "var VAL_{$entry_name}_nrdisk = $nrdisk, VAL_{$entry_name}_actdisk = $actdisk, VAL_{$entry_name}_workdisk = $workdisk;\n";
                        $vars[] = "var VAL_{$entry_name}_faildisk = $faildisk, VAL_{$entry_name}_sparedisk = $sparedisk, VAL_{$entry_name}_resync = $resync, VAL_{$entry_name}_recovery = $recovery;\n";
                    } else {
                        $vars[] = "var VAL_{$entry_name} = $acq;\n";
                    }
                }
                if (!strcmp($attribute, OID_ATTR_HEALTH_TABLE)) {
                    $table_indexes = acquire_multiple_values($snmp_source_ip_address, $snmp_source_community, $entry_oid);
                    $table_entry_name = $HTTP_SESSION_VARS["{$entry_name}_name"];
                    $table_entry_value_type = $HTTP_SESSION_VARS["{$entry_name}_value_type"];
                    $table_entry_description = $HTTP_SESSION_VARS["{$entry_name}_description"];
                    $table_entry_attribute = $HTTP_SESSION_VARS["{$entry_name}_attribute"];
                    if (!empty($table_indexes))
                        foreach ($table_indexes as $index_value) {
                            foreach ($table_entry_name as $each_entry_oid => $each_entry_name) {
                                $var_full_name = str_replace('.', '_', "{$entry_name}_{$each_entry_name}_{$index_value}");
                                $full_each_oid = "$each_entry_oid.$index_value";
                                $each_value_type = $table_entry_value_type[$each_entry_oid];
                                $acq = acquire_single_value_non_leaf($snmp_source_ip_address, $snmp_source_community, $full_each_oid, $each_value_type);
                                $vars[] = "var VAL_{$var_full_name} = $acq;\n";
                                if (!strcmp($table_entry_attribute[$each_entry_oid], OID_ATTR_WATCH)) {
                                    $vars[] = "var CNT_{$var_full_name} = 1, AVG_{$var_full_name} = $acq, MIN_{$var_full_name} = $acq, MAX_{$var_full_name} = $acq;\n";
                                    $vars[] = "var TRY_{$var_full_name} = 0, LSV_{$var_full_name} = 0;\n";
                                }
                            }
                        }
                }
                if (!empty($translation)) {
                    $translation_table = $HTTP_SESSION_VARS[$translation];
                    $vars[] = "var TRANS_{$entry_name} = new Array ();\n";
                    foreach ($translation_table as $value => $description) {
                        $vars[] = "TRANS_{$entry_name}[\"{$value}\"] = \"$description\";\n";
                    }
                }

                if (!empty($snmp_entry_alarm[$entry_oid])) {
                    $status = ALARM_NORMAL;
                    $vars[] = "var T{$entry_name} = \"$status\";\n";
                    $status = OID_ALARM_NORMAL;
                    $vars[] = "var MSG_{$entry_name} = \"$status\";\n";
                    $vars[] = "var MSGD_{$entry_name} = \"\";\n";
                }
                if (!strcmp($attribute, OID_ATTR_WATCH) &&
                    !strcmp($value_type, OID_VALUE_INTEGER)) {
                    $vars[] = "var CNT_{$entry_name} = 1, AVG_{$entry_name} = $acq, MIN_{$entry_name} = $acq, MAX_{$entry_name} = $acq;\n";
                    $vars[] = "var TRY_{$entry_name} = 0, LSV_{$entry_name} = 0;\n";
                }
            }

?>
<script language="javascript">
<!--
<?php
        for ($i = 0; $i < count($vars); $i++) {
            echo $vars[$i];
        }

        if ($GLOBALS["enable_profile"] > 0) {
            $profile_for_init = $HTTP_SESSION_VARS["profile_for_init"];
            if ((int)$profile_for_init == 0) {
                openlog("ASWM [{$snmp_source_community}@{$snmp_source_ip_address}]", LOG_CONS | LOG_NDELAY, LOG_USER);
                $dt = date("r (T)");
                syslog(LOG_INFO, "Profile Framework on {$dt}");
                closelog();
            }
        }
?>

var __refresh_milliseconds__ = <?php echo $HTTP_SESSION_VARS['refresh_milliseconds']; ?>;

var __refresh_enable__ = <?php echo $HTTP_SESSION_VARS['refresh_enable']; ?>;

var __vnc_display_number__ = <?php echo $HTTP_SESSION_VARS['vnc_display_number']; ?>;

var __healthTimeOut__ = null;

var __already_set_reboot__ = false;

var __in_summary_view__ = false;

var __platform_in_form_submit__ = false;

<?php
    $platform = $HTTP_GET_VARS["s"];
    $panel = $HTTP_GET_VARS["p"];
?>

var __platform_in_view__ = '<?php echo $platform;?>';

var __panel_in_view__ = '<?php echo $panel;?>';

var jsstartup = false;
//-->
</script>
<?php if (strpos($HTTP_USER_AGENT, 'MS') === false) { ?>
<frameset rows="1,76,*" frameborder="0" border="0" framespacing="0">
<?php } else{ ?>
<frameset rows="1,72,*" frameborder="0" border="0" framespacing="0">
<?php }?>
  <frame name="<?php echo FRAME_UPDATER;?>" scrolling="no" noresize src="_blank_.html" marginwidth="0" marginheight="0">
  <frame name="banner" scrolling="no" noresize src="<?php echo $HTTP_SESSION_VARS["localepath"];?>banner.php" marginwidth="0" marginheight="0">
  <frameset cols="220,*" frameborder="0" border="0" framespacing="0">
    <frameset rows="3,*" frameborder="0" border="0" framespacing="0">
        <frame name="health" src="_blank2_.html" marginwidth="0" marginheight="0" scrolling="no">
        <frame name="panel" src="indexpn.php" marginwidth="0" marginheight="0" scrolling="no">
    </frameset>
<?php if (strpos($HTTP_USER_AGENT, 'MS') === false) { ?>
    <frame name="platform" src="indexsm.php" marginwidth="0" marginheight="0" scrolling="auto">
<?php } else{ ?>
    <frame name="platform" src="indexsm.php" marginwidth="0" marginheight="0" scrolling="yes">
<?php }?>
  </frameset>
</frameset>
<?php } else {?>
<body onload="window.location.replace('framewrk.php')">
</body>
<?php } ?>
</html>