<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
$sid = session_id(md5(uniqid(rand())));
ini_alter("session.auto_start", "1");

$no_i18n = 1;

include("___defines___.php");
include("___defines2___.php");

$global_snmp_source_initiated = false;
$authorized_clients_checked = false;

$i18n = '';
$cntype = '';

$oid_enquiry_cache[EMPTY_OID] = '';

function acquire_single_value_with_cache ($ip_addr, $community, $oid, $value_type)
{
    global $oid_enquiry_cache;

    if (!empty($oid_enquiry_cache[$oid]))
        return $oid_enquiry_cache[$oid];
    $acq = acquire_single_value($ip_addr, $community, $oid, $value_type);
    $oid_enquiry_cache[$oid] = $acq;
    return $acq;
}

if ($GLOBALS["aswm_snmp_log"] != 0) {
    $fp = @fopen(DEBUG_LOGFILE, "w");
    if ($fp !== false) {
        $dt = date("r (T)");
        @fputs($fp, "------------ [$dt] ------------\n");
        fclose($fp);
    }
}


$ip = $HTTP_GET_VARS['ip'];
if (!empty($ip)) {
    $name = GLOBAL_SNMP_SOURCE_IP_ADDRESS;
    $$name = $ip;
    session_register($name);
    $name = GLOBAL_SNMP_SOURCE_COMMUNITY;
    $$name = $HTTP_GET_VARS['comm'];
    session_register($name);
    $global_snmp_source_initiated = true;
} else {
    $fp = @fopen(WEBCONSOURCE_INI, "r");
    if ($fp !== false) {
        $name = GLOBAL_SNMP_SOURCE_IP_ADDRESS;
        $$name = chop(@fgets($fp, 4096));
        if (!strcmp($$name, MATCHALL)) {
            $$name = $SERVER_NAME;
        }
        session_register($name);
        $name = GLOBAL_SNMP_SOURCE_COMMUNITY;
        $$name = chop(@fgets($fp, 4096));
        session_register($name);
        $global_snmp_source_initiated = true;
        @fclose($fp);
    }
}

$fp = @fopen(WEBCONCLIENTS_INI, "r");
if ($fp !== false) {
    while (!@feof($fp)) {
        $client = chop(@fgets($fp, 128));
        if (!strcmp($client, MATCHALL)) {
            $authorized_clients_checked = true;
            break;
        }
        if (strncmp(substr($client, strlen($client) - 1, 1), '.', 1))
            $client = "{$client}.";
        if (!strncmp("{$REMOTE_ADDR}.", $client, strlen($client))) {
            $authorized_clients_checked = true;
            break;
        }
    }
    @fclose($fp);
} else {
    $authorized_clients_checked = true;
}

if ($global_snmp_source_initiated && $authorized_clients_checked) {

    $fp = @fopen(WEBCONI18N_INI, "r");
    if ($fp !== false) {
        $buffer = chop(@fgets($fp, 4096));
        $cntype1 = chop(@fgets($fp, 4096));
        fclose($fp);
        if (!strcmp($buffer, I18N_JA)) {
            $i18n = I18N_JA_PREFIX_DIR;
        }
        if (!strcmp($buffer, I18N_CN)) {
            $i18n = I18N_CN_PREFIX_DIR;
        }
        if (!strcmp($buffer, I18N_EN)) {
            $i18n = I18N_EN_PREFIX_DIR;
        }
        $cntype = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset={$cntype1}\">\n";
    }

    if (!strcmp($HTTP_GET_VARS['rs'], 'def')) {
        $prev_i18n = $i18n;
        session_register('prev_i18n');
        $i18n = I18N_EN_PREFIX_DIR;
        $cntype = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=". I18N_DEFAULT_CTYPE. "\">\n";
    }

    $fp = @fopen($i18n. WEBCONVARS_INI, "r");
    $localepath = $i18n;

    $nested_ini = array(WEBCONVARS_INI);

    if ($fp !== false) {
        do {
            $scan_comment = false;
            $secflags[INIFILE_SEC_GLOBAL]                   = false;
            $secflags[INIFILE_SEC_GLOBAL_MULTIPLE]          = false;
            $secflags[INIFILE_SEC_TOP_CATEGORY]             = false;
            $secflags[INIFILE_SEC_2ND_CATEGORY]             = false;
            $secflags[INIFILE_SEC_2ND_CATEGORY_REDEFINE]    = false;
            $secflags[INIFILE_SEC_SUMMARY_CATEGORY]         = false;
            $secflags[INIFILE_SEC_SUMMARY_VIEW]             = false;
            $secflags[INIFILE_SEC_OID_SCAN]                 = false;
            $secflags[INIFILE_SEC_FORCE_TO_ADD_OID]         = false;
            $secflags[INIFILE_SEC_FORCE_TO_DELETE_OID]      = false;
            $secflags[INIFILE_SEC_OID_RESCAN_MAP]           = false;
            $secflags[INIFILE_SEC_OID]                      = false;
            $secflags[INIFILE_SEC_OID_TABLE_ENTRY]          = false;
            $secflags[INIFILE_SEC_OID_TABLE_MULTIPLE_INDEX] = false;
            $secflags[INIFILE_SEC_OID_VALUE_TRANSLATION_TABLE] = false;
            $secflags[INIFILE_SEC_OID_VALUE_TRANSLATION]    = false;
            $secflags[INIFILE_SEC_OID_PREFER_DISPLAY_PATTERN] = false;
            $secflags[INIFILE_SEC_POLLING_FOREVER]          = false;
            $secflags[INIFILE_SEC_ALARM_ACTION]             = false;
            $secflags[INIFILE_SEC_POLLING_ACTION]           = false;
            $secflags[INIFILE_SEC_CONFIG_ACTION]            = false;
            $secflags[INIFILE_SEC_RT_CHART]                 = false;
            $secflags[INIFILE_SEC_TRANSLATE]                = false;
            $secflags[INIFILE_SEC_SECURED_COMMUNITY]        = false;
            $secflags[INIFILE_SEC_STATIC_VALUE]             = false;
            $secflags[INIFILE_SEC_STATIC_EVENT_REMAP]       = false;

            while (!@feof($fp)) {
                $buffer = chop(@fgets($fp, 4096));

                if (strlen($buffer) < 4)
                    continue;

                if (!strcmp($buffer, INIFILE_COMMENT_BEGIN)) {
                    $scan_comment = true;
                    continue;
                }
                if (!strcmp($buffer, INIFILE_COMMENT_END)) {
                    $scan_comment = false;
                    continue;
                }

                if ($scan_comment)
                    continue;

                if (!strncmp($buffer, INIFILE_COMMENT_SINGLE_LINE, strlen(INIFILE_COMMENT_SINGLE_LINE)))
                    continue;

                if (strpos($buffer, "[") === 0) {
                    if (in_array($buffer, array_keys($secflags))) {
                        foreach ($secflags as $id => $var)
                            $secflags[$id] = false;
                        $secflags[$buffer] = true;
                        continue;
                    }
                    array_push($nested_ini, str_replace(']', '', substr($buffer, 1)));
                }

                if (strlen($buffer) > 1 && (strpos($buffer, "[") === false || strpos($buffer, "[") !=0)) {
                    if ($secflags[INIFILE_SEC_GLOBAL]) {
                        list($key, $value) = explode('=', $buffer);
                        $GLOBALS[$key] = $value;
                        ${$key} = stripcslashes($value);
                        session_register($key);
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_RT_CHART]) {
                        $rtchart_buffers[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_GLOBAL_MULTIPLE]) {
                        $global_multiple_buffer[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_SUMMARY_CATEGORY]) {
                        $summary_category_buffer[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_SUMMARY_VIEW]) {
                        $summary_view_buffer[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_OID_PREFER_DISPLAY_PATTERN]) {
                        $display_pattern_buffer[] = $buffer;
                        continue;
                    }


                    if ($secflags[INIFILE_SEC_OID_RESCAN_MAP]) {
                        $rescan_map_buffers[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_ALARM_ACTION]) {
                        $alarm_action_buffers[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_POLLING_ACTION]) {
                        $polling_action_buffers[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_CONFIG_ACTION]) {
                        $config_action_buffers[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_TRANSLATE]) {
                        $i18n_translate_buffers[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_SECURED_COMMUNITY]) {
                        list($entry_oid, $secured_comm) = explode('=', $buffer);
                        $secured_community[$entry_oid] = $secured_comm;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_POLLING_FOREVER]) {
                        list($model, $oids) = explode(',', $buffer);
                        $alloid = explode(':', $oids);
                        if (!strcmp($model, '*')) {
                            foreach ($alloid as $oid)
                                $polling_forever[] = $oid;
                        }
                        else {
                            $system_model_acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $system_model_identify_oid, OID_VALUE_INTEGER);
                            if (!strncmp($model, '^', 1)) {
                                $model = substr($model, 1);
                                if (strcmp($system_model_acq, $model)) {
                                    foreach ($alloid as $oid)
                                        $polling_forever[] = $oid;
                                }
                            } else if (!strcmp($system_model_acq, $model)) {
                                foreach ($alloid as $oid)
                                    $polling_forever[] = $oid;
                            }
                        }
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_STATIC_VALUE]) {
                        list($modeloid, $val) = explode('=', $buffer);
                        list($model, $oid) = explode(',', $modeloid);
                        if (!strcmp($model, '*')) {
                            $static_values[$oid] = $val;
                        }
                        else {
                            $system_model_acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $system_model_identify_oid, OID_VALUE_INTEGER);
                            if (!strncmp($model, '^', 1)) {
                                $model = substr($model, 1);
                                if (strcmp($system_model_acq, $model)) {
                                    $static_values[$oid] = $val;
                                }
                            } else if (!strcmp($system_model_acq, $model)) {
                                $static_values[$oid] = $val;
                            }
                        }
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_STATIC_EVENT_REMAP]) {
                        list($modelev, $newe) = explode('=', $buffer);
                        list($model, $oid) = explode(',', $modelev);
                        if (!strcmp($model, '*')) {
                            $static_event_remap[$oid] = $newe;
                        }
                        else {
                            $system_model_acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $system_model_identify_oid, OID_VALUE_INTEGER);
                            if (!strncmp($model, '^', 1)) {
                                $model = substr($model, 1);
                                if (strcmp($system_model_acq, $model)) {
                                    $static_event_remap[$oid] = $newe;
                                }
                            } else if (!strcmp($system_model_acq, $model)) {
                                $static_event_remap[$oid] = $newe;
                            }
                        }
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_TOP_CATEGORY]) {
                        list($index, $image) = explode('=', $buffer);
                        list($cid, $name, $flash) = explode(',', $index);
                        $top_category[$cid] = $name;
                        $top_category_flash[$cid] = $flash;
                        $top_category_image[$cid] = $image;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_2ND_CATEGORY]) {
                        list($cid, $view, $sort, $subp, $name, $title, $category_exist_enquiry, $value_type, $exist_value, $fldtag) = explode(',', $buffer);
                        if (strcmp($category_exist_enquiry, EMPTY_OID)) {
                            $acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $category_exist_enquiry, $value_type);
                            if (!strcmp($value_type, OID_VALUE_STRING))
                                $acq = ereg_replace("^\"", '', ereg_replace("\"$", '', $acq));
                            if (check_oid_exist($exist_value, $acq)) {
                                $second_category[$cid] = stripcslashes($name);
                                $second_category_view[$cid] = $view;
                                $second_category_sort[$cid] = $sort;
                                $second_category_subplatform[$cid] = $subp;
                                $second_category_title[$cid] = stripcslashes($title);
                                $second_category_alarm[$cid] = ALARM_EMPTY;
                                $second_category_warning_alarm[$cid] = ALARM_EMPTY;
                                $second_category_field_tag[$cid] = $fldtag;
                            }
                        } else {
                            $second_category[$cid] = stripcslashes($name);
                            $second_category_view[$cid] = $view;
                            $second_category_sort[$cid] = $sort;
                            $second_category_subplatform[$cid] = $subp;
                            $second_category_title[$cid] = stripcslashes($title);
                            $second_category_alarm[$cid] = ALARM_EMPTY;
                            $second_category_warning_alarm[$cid] = ALARM_EMPTY;
                            $second_category_field_tag[$cid] = $fldtag;
                        }
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_2ND_CATEGORY_REDEFINE]) {
                        $second_category_redefine[] = $buffer;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_OID_TABLE_ENTRY]) {
                        list($oid, $tbl_name, $name, $value_type, $attribute, $description) = explode(',', $buffer);

                        $array_name = "{$tbl_name}_name";
                        ${$array_name}[$oid] = $name;
                        $array_name = "{$tbl_name}_value_type";
                        ${$array_name}[$oid] = $value_type;
                        $array_name = "{$tbl_name}_attribute";
                        ${$array_name}[$oid] = $attribute;
                        $array_name = "{$tbl_name}_description";
                        ${$array_name}[$oid] = stripcslashes($description);
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_OID_TABLE_MULTIPLE_INDEX]) {
                        list($oid, $tbl_name, $name, $value_type) = explode(',', $buffer);

                        $array_name = "{$tbl_name}_name_multindex";
                        ${$array_name}[$oid] = $name;
                        $array_name = "{$tbl_name}_value_type_multindex";
                        ${$array_name}[$oid] = $value_type;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_OID_SCAN]) {
                        list($rescan_map, $oid, $oid_exist_enquiry, $value_type, $exist_value) = explode(',', $buffer);
                        if (empty($snmp_oid_exist_enquiry[$oid])) {
                            $snmp_oid_exist_enquiry[$oid] = $oid_exist_enquiry;
                            $snmp_oid_exist_enquiry_value[$oid] = $exist_value;
                            $snmp_oid_exist_enquiry_value_type[$oid] = $value_type;
                        } else {
                            $additional_snmp_oid_exist_enquiry = str_replace('.', '_', $oid);
                            $additional_snmp_oid_exist_enquiry = "snmp_oid_exist_enquiry_{$additional_snmp_oid_exist_enquiry}";
                            ${$additional_snmp_oid_exist_enquiry}[count($$additional_snmp_oid_exist_enquiry)] = $oid_exist_enquiry;
                            $additional_snmp_oid_exist_enquiry_value = str_replace('.', '_', $oid);
                            $additional_snmp_oid_exist_enquiry_value = "snmp_oid_exist_enquiry_value_{$additional_snmp_oid_exist_enquiry_value}";
                            ${$additional_snmp_oid_exist_enquiry_value}[count($$additional_snmp_oid_exist_enquiry_value)] = $exist_value;
                            $additional_snmp_oid_exist_enquiry_value_type = str_replace('.', '_', $oid);
                            $additional_snmp_oid_exist_enquiry_value_type = "snmp_oid_exist_enquiry_value_type_{$additional_snmp_oid_exist_enquiry_value_type}";
                            ${$additional_snmp_oid_exist_enquiry_value_type}[count($$additional_snmp_oid_exist_enquiry_value_type)] = $value_type;
                        }

                        if (strcmp($rescan_map, '_')) {
                            $oid_scan_buffers[] = $buffer;
                            $reserve_oid_for_remap[] = $oid;
                        }
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_FORCE_TO_ADD_OID]) {
                        list($model, $oids) = explode(',', $buffer);
                        $system_model_acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $system_model_identify_oid, OID_VALUE_INTEGER);
                        if (!strcmp($system_model_acq, $model)) {
                            foreach (explode(':', $oids) as $oid) {
                                $force_to_add_oids[$oid] = $oid;
                            }
                        }
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_FORCE_TO_DELETE_OID]) {
                        list($model, $oids) = explode(',', $buffer);
                        $system_model_acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $system_model_identify_oid, OID_VALUE_INTEGER);
                        if (!strcmp($system_model_acq, $model)) {
                            foreach (explode(':', $oids) as $oid) {
                                $force_to_delete_oids[$oid] = $oid;
                            }
                        }
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_OID_VALUE_TRANSLATION_TABLE]) {
                        list($table_name, $value, $description) = explode(',', $buffer);
                        ${$table_name}[$value] = stripcslashes($description);
                        $global_translation_table[$table_name] = $table_name;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_OID_VALUE_TRANSLATION]) {
                        list($oid, $tanslation_table_name) = explode(',', $buffer);
                        $snmp_entry_value_translation[$oid] = $tanslation_table_name;
                        continue;
                    }

                    if ($secflags[INIFILE_SEC_OID]) {
                        $add_without_problem = true;

                        list($oid, $name, $value_type, $attribute, $web_category, $parent_oid, $description) = explode(',', $buffer);
                        list($topc, $secondc) = explode('.', $web_category);

                        if (!empty($reserve_oid_for_remap))
                            if (in_array($oid, $reserve_oid_for_remap))
                                $snmp_entry_raw_buffer_reserve_for_remap[$oid] = $buffer;

                        $oid_exist_enquiry = $snmp_oid_exist_enquiry[$oid];

                        if (empty($second_category[$secondc]))
                            $add_without_problem = false;

                        if (!empty($oid_exist_enquiry)) {
                            if (strcmp($oid_exist_enquiry, EMPTY_OID)) {
                                $vtype = $snmp_oid_exist_enquiry_value_type[$oid];
                                $acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $oid_exist_enquiry, $vtype);
                                $add_without_problem = check_oid_exist($snmp_oid_exist_enquiry_value[$oid], $acq);

                                $additional_snmp_oid_exist_enquiry = str_replace('.', '_', $oid);
                                $additional_snmp_oid_exist_enquiry = "snmp_oid_exist_enquiry_{$additional_snmp_oid_exist_enquiry}";
                                $additional_snmp_oid_exist_enquiry_value = str_replace('.', '_', $oid);
                                $additional_snmp_oid_exist_enquiry_value = "snmp_oid_exist_enquiry_value_{$additional_snmp_oid_exist_enquiry_value}";
                                $additional_snmp_oid_exist_enquiry_value_type = str_replace('.', '_', $oid);
                                $additional_snmp_oid_exist_enquiry_value_type = "snmp_oid_exist_enquiry_value_type_{$additional_snmp_oid_exist_enquiry_value_type}";

                                if (!empty($$additional_snmp_oid_exist_enquiry)) {
                                    ksort($$additional_snmp_oid_exist_enquiry);
                                    ksort($$additional_snmp_oid_exist_enquiry_value);
                                    ksort($$additional_snmp_oid_exist_enquiry_value_type);
                                    foreach ($$additional_snmp_oid_exist_enquiry as $k => $each_oid_exist_enquiry) {
                                        list($k2, $each_oid_exist_enquiry_value) = each($$additional_snmp_oid_exist_enquiry_value);
                                        $acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $each_oid_exist_enquiry, 
                                            each($$additional_snmp_oid_exist_enquiry_value_type));
                                        $add_without_problem = (boolean)($add_without_problem && check_oid_exist($each_oid_exist_enquiry_value, $acq));
                                    }
                                }
                            }
                        }

                        if (!strcmp($attribute, OID_ATTR_HLIMIT) || !strcmp($attribute, OID_ATTR_LLIMIT)
                            || !strcmp($attribute, OID_ATTR_WHLIMIT) || !strcmp($attribute, OID_ATTR_WLLIMIT)
                            || !strcmp($attribute, OID_ATTR_POP_INFO_EX) || !strcmp($attribute, OID_ATTR_POP_INFO_RAID)
                            || !strcmp($attribute, OID_ATTR_POP_INFO_EX_COMPOSITE))
                            if (empty($snmp_entry_name[$parent_oid])) {
                                $add_without_problem = false;
                            }

                        if (!$add_without_problem) {
                            if (!empty($force_to_add_oids))
                                if (!empty($force_to_add_oids[$oid]))
                                    $add_without_problem = true;
                        }
                        if ($add_without_problem) {
                            if (!empty($force_to_delete_oids))
                                if (!empty($force_to_delete_oids[$oid]))
                                    $add_without_problem = false;
                        }

                        if ($add_without_problem) {
                            $snmp_entry_name[$oid] = $name;
                            $snmp_entry_oid[$name] = $oid;
                            $snmp_entry_value_type[$oid] = $value_type;
                            $snmp_entry_attribute[$oid] = stripcslashes($attribute);
                            if (strcmp($description, "_"))
                                $snmp_entry_description[$oid] = stripcslashes($description);

                            $ok_to_2nd_cat = false;
                            if (!strcmp($parent_oid, EMPTY_OID)) {
                                $ok_to_2nd_cat = true;
                            } else {
                                $snmp_entry_parent_oid[$oid] = $parent_oid;
                                $snmp_entry_haskids_oid[$parent_oid] = true;
                                if (strpos($parent_oid, ':') !== false)
                                    $ok_to_2nd_cat = true;
                                else {
                                    $parent_attribute = $snmp_entry_attribute[$parent_oid];
                                    if (!strcmp($parent_attribute, OID_ATTR_POP_INFO_EX_COMPOSITE)) {
                                        $parent_name = $snmp_entry_name[$parent_oid];
                                        $array = "snmp_composite_info_ex_{$parent_name}";
                                        ${$array}[] = $oid;
                                        $snmp_entry_composite_info_ex[$array] = $array;
                                        $ok_to_2nd_cat = true;
                                    }
                                }
                            }

                            if ($ok_to_2nd_cat) {
                                ${$secondc}[$oid] = $attribute;
                            }

                            $snmp_entry_2nd_category[$oid] = $secondc;

                            if (!strcmp($attribute, OID_ATTR_ALARM) || !strcmp($attribute, OID_ATTR_DEALARM)
                                || !strcmp($attribute, OID_ATTR_WALARM)) {
                                $snmp_entry_alarm[$parent_oid] = ALARM_NORMAL;
                            }

                            if (!strcmp($attribute, OID_ATTR_TABLE) || !strcmp($attribute, OID_ATTR_VERTICAL_TABLE) ||
                                !strcmp($attribute, OID_ATTR_HEALTH_TABLE) ||
                                !strcmp($attribute, OID_ATTR_MULTINDEX_TABLE) || !strcmp($attribute, OID_ATTR_VERTICAL_MULTINDEX_TABLE)) {
                                $snmp_table_entry[$oid] = $name;
                                if (!strcmp($attribute, OID_ATTR_MULTINDEX_TABLE) || !strcmp($attribute, OID_ATTR_VERTICAL_MULTINDEX_TABLE)) {
                                    $snmp_table_entry_multindex[$oid] = $name;
                                }
                            }

                            if (!strcmp($attribute, OID_ATTR_HLIMIT)) {
                                $snmp_entry_hlimit[$parent_oid] = $oid;
                            }
                            if (!strcmp($attribute, OID_ATTR_LLIMIT)) {
                                $snmp_entry_llimit[$parent_oid] = $oid;
                            }
                            if (!strcmp($attribute, OID_ATTR_WHLIMIT)) {
                                $snmp_entry_whlimit[$parent_oid] = $oid;
                            }
                            if (!strcmp($attribute, OID_ATTR_WLLIMIT)) {
                                $snmp_entry_wllimit[$parent_oid] = $oid;
                            }

                            if (!strcmp($attribute, OID_ATTR_POP_INFO_EX) 
                                || !strcmp($attribute, OID_ATTR_POP_INFO_RAID)
                                || !strcmp($attribute, OID_ATTR_POP_INFO_EX_COMPOSITE)) {
                                $snmp_entry_pop_extended_info[$parent_oid] = $oid;
                            }

                            if (!strcmp($attribute, OID_ATTR_CONFIG)) {
                                $snmp_entry_config[$parent_oid] = $oid;
                            }
                        }
                    }
                }
            }
            @fclose($fp);

            if (!empty($nested_ini)) {
                $last_ini = array_pop($nested_ini);
                if (count($nested_ini) > 0) {
                    $fp = @fopen($last_ini, "r");
                    if ($fp === false)
                        break;
                } else
                    break;
            }

        } while (true);

        session_register('snmp_entry_name');
        session_register('snmp_entry_oid');
        session_register('snmp_entry_value_type');
        session_register('snmp_entry_attribute');
        session_register('snmp_entry_parent_oid');
        if (!empty($snmp_entry_haskids_oid))
            session_register('snmp_entry_haskids_oid');
        session_register('snmp_entry_description');
        session_register('snmp_entry_value_translation');

        ksort($snmp_entry_2nd_category);
        session_register('snmp_entry_2nd_category');
        session_register('snmp_entry_alarm');

        session_register('snmp_entry_hlimit');
        session_register('snmp_entry_llimit');
        session_register('snmp_entry_whlimit');
        session_register('snmp_entry_wllimit');
        session_register('snmp_entry_pop_extended_info');

        session_register('snmp_entry_config');

        session_register('top_category');
        session_register('top_category_flash');
        session_register('top_category_image');
        session_register('second_category');
        session_register('second_category_view');
        session_register('second_category_sort');
        session_register('second_category_title');
        session_register('second_category_subplatform');
        session_register('second_category_alarm');
        session_register('second_category_warning_alarm');
        session_register('second_category_field_tag');

        if (!empty($second_category_redefine))
            session_register('second_category_redefine');

        if (!empty($force_to_add_oids))
            session_register('force_to_add_oids');

        if (!empty($force_to_delete_oids))
            session_register('force_to_delete_oids');

        if (!empty($secured_community))
            session_register('secured_community');
        if (!empty($snmp_entry_raw_buffer_reserve_for_remap))
            session_register('snmp_entry_raw_buffer_reserve_for_remap');

        if (!empty($polling_forever))
            session_register('polling_forever');

        if (!empty($static_values))
            session_register('static_values');

        if (!empty($static_event_remap))
            session_register('static_event_remap');

        if (!empty($snmp_table_entry))
            foreach ($snmp_table_entry as $tbl_name) {
                $array_name = "{$tbl_name}_name";
                session_register($array_name);
                $array_name = "{$tbl_name}_value_type";
                session_register($array_name);
                $array_name = "{$tbl_name}_attribute";
                session_register($array_name);
                $array_name = "{$tbl_name}_description";
                session_register($array_name);
            }

        if (!empty($snmp_table_entry_multindex))
            foreach ($snmp_table_entry_multindex as $tbl_name) {
                $array_name = "{$tbl_name}_name_multindex";
                session_register($array_name);
                $array_name = "{$tbl_name}_value_type_multindex";
                session_register($array_name);
            }
        
        if (!empty($snmp_entry_composite_info_ex))
            foreach ($snmp_entry_composite_info_ex as $array) {
                session_register($array);
            }

        foreach ($second_category as $id => $name) {
            if (!empty($$id)) {
                if (!strcmp($second_category_sort[$id], SECOND_CATEGORY_NEEDSORT))
                    uksort($$id, 'kstrnatcmp');
                session_register($id);
            }
        }

        if (!empty($global_translation_table))
            foreach ($global_translation_table as $var_name) {
                session_register($var_name);
            }

        if (!empty($summary_category_buffer))
            session_register('summary_category_buffer');
        if (!empty($summary_view_buffer))
            session_register('summary_view_buffer');
        if (!empty($global_multiple_buffer))
            session_register('global_multiple_buffer');
        if (!empty($display_pattern_buffer))
            session_register('display_pattern_buffer');
        if (!empty($rescan_map_buffers))
            session_register('rescan_map_buffers');
        if (!empty($oid_scan_buffers))
            session_register('oid_scan_buffers');
        if (!empty($alarm_action_buffers))
            session_register('alarm_action_buffers');
        if (!empty($polling_action_buffers))
            session_register('polling_action_buffers');
        if (!empty($config_action_buffers))
            session_register('config_action_buffers');
        if (!empty($rtchart_buffers))
            session_register('rtchart_buffers');
        if (!empty($i18n_translate_buffers))
            session_register('i18n_translate_buffers');

        $postpone_scan_event = 0;
        $snmp_events = "@0";
        $imitation_events = "";
        $ignore_first_action_event = true;

        session_register('snmp_events');
        session_register('imitation_events');
        session_register('postpone_scan_event');
        session_register('ignore_first_action_event');
    }

    session_register('i18n');
    session_register('cntype');

    session_register('localepath');

    openlog("ASWM [{$snmp_source_ip_address}]", LOG_CONS | LOG_NDELAY, LOG_USER);
//    $hostname = gethostbyaddr($REMOTE_ADDR);
//    $dt = date("r (T)");
    syslog(LOG_INFO, "User {$REMOTE_USER} logon from {$REMOTE_ADDR} with agent ({$HTTP_USER_AGENT})");
    closelog();
    $platform = $HTTP_GET_VARS['s'];
    $panel = $HTTP_GET_VARS['p'];

    $browsernosupport = false;
    if (strpos($HTTP_USER_AGENT, 'Mozilla/') !== false) {
        if (!strcmp($i18n, I18N_CN_PREFIX_DIR)) {
            if (strpos($HTTP_USER_AGENT, '/4.7') !== false && strpos($HTTP_USER_AGENT, '[en]') !== false) {
                $browsernosupport = true;
            }
        }
        if (!strcmp($i18n, I18N_JA_PREFIX_DIR)) {
            if (strpos($HTTP_USER_AGENT, '/4.7') !== false && strpos($HTTP_USER_AGENT, '[en]') !== false) {
                $browsernosupport = true;
            }
        }
    } else {
        $browsernosupport = true;
    }

    if ($browsernosupport) {
?>
<HEAD>
<title>ASUS System Web-base Management</title>
<?php if (strpos($HTTP_USER_AGENT, 'X11') === false) { ?>
<LINK href="/i18n/en/__defines__.css" rel=stylesheet type="text/css">
<LINK href="/i18n/en/__defines_jally__.css" rel=stylesheet type="text/css">
<?php } else{ ?>
<LINK href="/i18n/en/__defines2__.css" rel=stylesheet type="text/css">
<LINK href="/i18n/en/__defines_jally2__.css" rel=stylesheet type="text/css">
<?php }?>
<?php
        session_unset();
        session_destroy();
    ?>
<script language=javascript>
<!--
    function restart_in_english () {
        top.location.replace("./index.php?rs=def");
    }
//-->
</script>
</HEAD>
<BODY BGCOLOR="#CEE7FF" marginwidth="0" marginheight="0" leftmargin="0" topmargin="0">
<TABLE width="778" border="0" cellspacing="0" cellpadding="0">
<TR>
	<TD colspan="3"><IMG SRC="/images/top-h1.gif"></TD>
</TR>
<TR valign="top">
	<TD width="135"><IMG SRC="/i18n/en/images/top-h2.gif"></TD>
	<TD width="616" bgcolor="#91B9E2" align="center" valign="middle" >
        <table width="593" border="0" cellspacing="0" cellpadding="0">
        <tr><TD align="left" class="Top-ConnectServer">&nbsp;<b><?php echo $SERVER_ADDR; ?></b></TD>
           <TD align="right" class="Top-button"><b>| <a id=white href="http://www.asus.com.tw/" target="web">www.asus.com.tw</a> |</b></TD>
	       </tr>
	       </table>
	</TD>
	<TD width="48"><IMG SRC="/images/top-h3.gif"></TD>
</TR>
<TR>
	<TD colspan="3">


<center><br><br><br><br><br><br><br>
<TABLE  width="400" height="150" border="0" cellspacing="0" cellpadding="0" bgcolor="#ECE9E9">
<TR>
    <TD  width="5" height="5" ><IMG SRC="./images/warn-b1.gif" BORDER=0 ALT=""></TD>
    <TD  width="391" height="5"  background="./images/warn-bg1.gif"><IMG SRC="./images/warn-bg1.gif" BORDER=0 ALT=""></TD>
    <TD  width="4" height="5" ><IMG SRC="./images/warn-b2.gif" BORDER=0 ALT=""></TD>
</TR>
<TR>
    <TD  width="5" height="141"  background="./images/warn-bg2.gif">&nbsp;</TD>
    <TD  width="391" height="141" bgcolor="#ECE9E9" align="center">
        <TABLE cellpadding="10">
        <TR>
            <TD align="left" class="Td-HealthItem"><div align=center><IMG SRC="./images/warning-p.gif" BORDER=0 ALT=""></div><BR>
            
<h2><font color=red>Your HTTP browser doesn't support International ASWM</font></h2>
<p><b>Browser type:</b> <?php echo $HTTP_USER_AGENT;?></p>
<h4><u>Possible reasons:</u></h4>
<ul>
<li>It is not Mozilla compatible.
<li>It is not ready for the international version of ASWM you connected to.<br>
    <b>N.B.</b> This site's ASWM (<?php echo $SERVER_ADDR; ?>) will show all following pages in <?php
        if (!strcmp($i18n, I18N_CN_PREFIX_DIR)) {
            echo "Simplified Chinese (GB2312)";
        }
        if (!strcmp($i18n, I18N_JA_PREFIX_DIR)) {
            echo "Japanese (EUC-JP)";
        }
        if (empty($i18n)) {
            echo "English (ISO-8859-1)";
        }
    ?> .<br>
    <font color=red>Some international browsers do not truely support international Java Script which is used extensively by ASWM.</font>
</ul>
<h4><font color=blue>Please contact ASWM administrator for further help.</font></h4>
<br>
<h4>If you prefer to enter ASWM in English,<br>click <a id=navy href="javascript: restart_in_english();">English ASWM</a> to continue.</h4>

            </TD>
        </TR>
        </TABLE>
    </TD>
    <TD  width="4" height="141"   background="./images/warn-bg3.gif">&nbsp;</TD>
</TR>
<TR>
    <TD  width="5" height="4"  ><IMG SRC="./images/warn-b3.gif" BORDER=0 ALT=""></TD>
    <TD  width="391" height="4"   background="./images/warn-bg4.gif" width="" height=""><IMG SRC="./images/warn-bg4.gif" BORDER=0 ALT=""></TD>
    <TD  width="4" height="4"  ><IMG SRC="./images/warn-b4.gif" BORDER=0 ALT=""></TD>
</TR>
</TABLE>
</center>

</TD>
</TR>
</TABLE>
</BODY>
</HTML>
<?php
        exit;
    }
?>
<html>
<head><title>ASUS System Web-base Management</title></head>
<body onload="window.location.replace('framewrk.php?s=' + escape('<?php echo $platform; ?>') + '&p=' + escape('<?php echo $panel; ?>'))">
</body>
</html>
<?php
} else {
?>
<HEAD>
<title>ASUS System Web-base Management</title>
<?php if (strpos($HTTP_USER_AGENT, 'X11') === false) { ?>
<LINK href="/i18n/en/__defines__.css" rel=stylesheet type="text/css">
<LINK href="/i18n/en/__defines_jally__.css" rel=stylesheet type="text/css">
<?php } else{ ?>
<LINK href="/i18n/en/__defines2__.css" rel=stylesheet type="text/css">
<LINK href="/i18n/en/__defines_jally2__.css" rel=stylesheet type="text/css">
<?php }?>
</HEAD>
<BODY BGCOLOR="#CEE7FF" marginwidth="0" marginheight="0" leftmargin="0" topmargin="0" >
<TABLE width="778" border="0" cellspacing="0" cellpadding="0">
<TR>
	<TD colspan="3"><IMG SRC="/images/top-h1.gif"></TD>
</TR>
<TR valign="top">
	<TD width="135"><IMG SRC="/i18n/en/images/top-h2.gif"></TD>
	<TD width="616" bgcolor="#91B9E2" align="center" valign="middle" >
        <table width="593" border="0" cellspacing="0" cellpadding="0">
        <tr><TD align="left" class="Top-ConnectServer">&nbsp;<b><?php echo $SERVER_ADDR; ?></b></TD>
           <TD align="right" class="Top-button"><b>| <a id=white href="http://www.asus.com.tw/" target="web">www.asus.com.tw</a> |</b></TD>
	       </tr>
	       </table>
	</TD>
	<TD width="48"><IMG SRC="/images/top-h3.gif"></TD>
</TR>
<TR>
	<TD colspan="3">

<center><br><br><br><br><br><br><br>
<TABLE  width="400" height="150" border="0" cellspacing="0" cellpadding="0" bgcolor="#ECE9E9">
<TR>
    <TD  width="5" height="5" ><IMG SRC="./images/warn-b1.gif" BORDER=0 ALT=""></TD>
    <TD  width="391" height="5"  background="./images/warn-bg1.gif"><IMG SRC="./images/warn-bg1.gif" BORDER=0 ALT=""></TD>
    <TD  width="4" height="5" ><IMG SRC="./images/warn-b2.gif" BORDER=0 ALT=""></TD>
</TR>
<TR>
    <TD  width="5" height="141"  background="./images/warn-bg2.gif">&nbsp;</TD>
    <TD  width="391" height="141" bgcolor="#ECE9E9" align="center">
        <TABLE cellpadding="10">
        <TR>
            <TD align="left" class="Td-HealthItem"><div align=center><IMG SRC="./images/warning-p.gif" BORDER=0 ALT=""></div><BR>
            
<h3><b><font color=red>Your IP <?php echo $REMOTE_ADDR;?> was denied to access by ASWM.</font></b></h3>
<h4><u>Possible reasons:</u></h4>
<ul>
<li>Initiative file is not found (or damaged).
<li>Server Information file is not found (or damaged).
<li>Clients Access file is not found (or damaged).
<li>Your IP address is blocked by ASWM Clients Access File.
</ul>
<h4><font color=blue>Please contact ASWM administrator for further help.</font></h4>


            </TD>
        </TR>
        </TABLE>
    </TD>
    <TD  width="4" height="141"   background="./images/warn-bg3.gif">&nbsp;</TD>
</TR>
<TR>
    <TD  width="5" height="4"  ><IMG SRC="./images/warn-b3.gif" BORDER=0 ALT=""></TD>
    <TD  width="391" height="4"   background="./images/warn-bg4.gif" width="" height=""><IMG SRC="./images/warn-bg4.gif" BORDER=0 ALT=""></TD>
    <TD  width="4" height="4"  ><IMG SRC="./images/warn-b4.gif" BORDER=0 ALT=""></TD>
</TR>
</TABLE>
</center>

</TD>
</TR>
</TABLE>
</BODY>
</HTML>
<?php
}
?>
