<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
include("___defines___.php");

$oid_enquiry_cache[EMPTY_OID] = '';

function acquire_single_value_with_cache ($ip_addr, $community, $oid, $value_type)
{
    global $oid_enquiry_cache;

    if (!empty($oid_enquiry_cache[$oid]))
        return $oid_enquiry_cache[$oid];
    $acq = acquire_single_value($ip_addr, $community, $oid, $value_type);
    $oid_enquiry_cache[$oid] = $acq;
    return $acq;
}

$panel_info_load = $HTTP_SESSION_VARS["panel_info_load"];

if ((int)$panel_info_load == 0) {
    $second_category_redefine = $HTTP_SESSION_VARS['second_category_redefine'];
    if (!empty($second_category_redefine)) {
        $system_model_identify_oid = $HTTP_SESSION_VARS['system_model_identify_oid'];
        if ($GLOBALS["dummy_snmp"] == 0)
            $system_model_acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $system_model_identify_oid, OID_VALUE_INTEGER);
        else
            $system_model_acq = $GLOBALS["dummy_backplane_id"];

        $second_category = $HTTP_SESSION_VARS['second_category'];
        $second_category_title = $HTTP_SESSION_VARS['second_category_title'];

        foreach ($second_category_redefine as $buffer) {
            list($acqid, $cid, $name, $title, $fieldtag) = explode(',', $buffer);
            if (!strcmp($acqid, $system_model_acq)) {
                $second_category[$cid] = stripcslashes($name);
                $second_category_title[$cid] = stripcslashes($title);
                if (!empty($fieldtag))
                    $second_category_field_tag[$cid] = $fieldtag;
            }
        }
    }

    $global_multiple_buffer = $HTTP_SESSION_VARS["global_multiple_buffer"];
    if (!empty($global_multiple_buffer)) {
        foreach ($global_multiple_buffer as $buffer) {
            list($xkey, $value) = explode('=', $buffer, 2);
            list($key, $id) = explode(',', $xkey);
            $global_variables[$key] = $key;
            ${$key}[$id] = stripcslashes($value);
        }
        if (!empty($global_variables))
            foreach ($global_variables as $var_name) {
                session_register($var_name);
            }
        session_unregister('global_multiple_buffer');
        unset($global_multiple_buffer);
    }

    $display_pattern_buffer = $HTTP_SESSION_VARS["display_pattern_buffer"];
    if (!empty($display_pattern_buffer)) {
        foreach ($display_pattern_buffer as $buffer) {
            list($item, $pattern) = explode(',', $buffer);
            $snmp_entry_prefer_display_pattern[$item] = $pattern;
        }
        session_register('snmp_entry_prefer_display_pattern');
        session_unregister('display_pattern_buffer');
        unset($display_pattern_buffer);
    }

    $oid_scan_buffers = $HTTP_SESSION_VARS["oid_scan_buffers"];
    if (!empty($oid_scan_buffers)) {
        foreach ($oid_scan_buffers as $buffer) {
            list($rescan_map, $oid, $oid_exist_enquiry, $value_type, $exist_value) = explode(',', $buffer);
            ${$rescan_map}[$oid] = "{$oid_exist_enquiry},{$value_type},{$exist_value}";
        }
        session_unregister('oid_scan_buffers');
        unset($oid_scan_buffers);
    }

    $rescan_map_buffers = $HTTP_SESSION_VARS["rescan_map_buffers"];
    if (!empty($rescan_map_buffers)) {
        foreach ($rescan_map_buffers as $buffer) {
            list($remap_oid, $mapname, $secondc) = explode(',', $buffer);
            $snmp_entry_rescan_map[$remap_oid] = $mapname;
            $snmp_entry_rescan_map_second_category[$mapname] = $secondc;
        }
        session_register('snmp_entry_rescan_map');
        session_register('snmp_entry_rescan_map_second_category');
        foreach ($snmp_entry_rescan_map as $map) {
            session_register($map);
        }
        session_unregister('rescan_map_buffers');
        unset($rescan_map_buffers);
    }

    $config_action_buffers = $HTTP_SESSION_VARS["config_action_buffers"];
    if (!empty($config_action_buffers)) {
        foreach ($config_action_buffers as $buffer) {
            list($act_oid, $actions) = explode('=', $buffer);
            $config_actions[$act_oid] = $actions;
        }
        session_register('config_actions');
        session_unregister('config_action_buffers');
        unset($config_action_buffers);
    }

    $alarm_action_buffers = $HTTP_SESSION_VARS["alarm_action_buffers"];
    if (!empty($alarm_action_buffers)) {
        foreach ($alarm_action_buffers as $buffer) {
            list($alarm_oid, $alarm_action, $action_para) = explode(',', $buffer);
            $alarm_actions[$alarm_oid] = $alarm_action;
            $alarm_actions_parameters[$alarm_oid] = $action_para;
        }
        session_register('alarm_actions');
        session_register('alarm_actions_parameters');
        session_unregister('alarm_action_buffers');
        unset($alarm_action_buffers);
    }

    $polling_action_buffers = $HTTP_SESSION_VARS["polling_action_buffers"];

    if (!empty($polling_action_buffers)) {
        foreach ($polling_action_buffers as $buffer) {
            list($tag, $poll_oid, $value_type, $old_value, $new_value, $action, $action_para) = explode(',', $buffer);
            $acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $poll_oid, $value_type);
            if (!check_oid_exist($new_value, $acq)) {
                $polling_actions_oid[$tag] = "{$poll_oid},{$value_type}";
                $polling_actions_condition[$tag] = "{$old_value},{$new_value}";
                $polling_actions[$tag] = $action;
                $polling_actions_parameters[$tag] = $action_para;
                $polling_oid_saved_values[$tag] = $acq;
            }
        }

        if (!empty($polling_actions_oid)) {
            session_register('polling_actions_oid');
            session_register('polling_actions_condition');
            session_register('polling_actions');
            session_register('polling_actions_parameters');
            session_register('polling_oid_saved_values');
        }
        session_unregister('polling_action_buffers');
        unset($polling_action_buffers);
    }

    $i18n_translate_buffers = $HTTP_SESSION_VARS["i18n_translate_buffers"];

    if (!empty($i18n_translate_buffers)) {
        foreach ($i18n_translate_buffers as $buffer) {
            list($oid_list, $transl) = explode('=', $buffer);
            list($from_text, $to_text) = explode(',', $transl);
            foreach (explode(',', $oid_list) as $each_oid) {
                $snmp_entry_textvalue_translation_oid[$each_oid] = $each_oid;
                $snmp_entry_textvalue_translation[$each_oid][$from_text] = stripcslashes($to_text);
            }
        }

        if (!empty($snmp_entry_textvalue_translation_oid)) {
            session_register('snmp_entry_textvalue_translation_oid');
            session_register('snmp_entry_textvalue_translation');
        }
        session_unregister('i18n_translate_buffers');
        unset($i18n_translate_buffers);
    }

    $snmp_entry_name = $HTTP_SESSION_VARS["snmp_entry_name"];
    $snmp_entry_value_type = $HTTP_SESSION_VARS["snmp_entry_value_type"];
    $snmp_entry_attribute = $HTTP_SESSION_VARS["snmp_entry_attribute"];

    foreach ($snmp_entry_value_type as $entry_oid => $value_type) {
        $attribute = $snmp_entry_attribute[$entry_oid];
        $entry_name = $snmp_entry_name[$entry_oid];
        $translation = $snmp_entry_value_translation[$entry_oid];
        if (!strcmp($attribute, OID_ATTR_HLIMIT) || !strcmp($attribute, OID_ATTR_LLIMIT) ||
            !strcmp($attribute, OID_ATTR_WHLIMIT) || !strcmp($attribute, OID_ATTR_WLLIMIT)) {
            $acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $entry_oid, $value_type);
            $vars[] = "top.VAL_{$entry_name} = $acq;\n";
        }
    }
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html>
<head>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
</head>
<BODY BGCOLOR="#CEE7FF" background="/images/f2-bg.gif" marginwidth="0" marginheight="0" leftmargin="0" topmargin="0">
</body>
<script language=javascript>
<!--
<?php
for ($i = 0; $i < count($vars); $i++) {
    echo $vars[$i];
}
?>
window.location.replace('panel.php');
//-->
</script>
</html>