<?php
//
// Copyright (C) 2001 by ASUSTeK Computer Inc. All rights reserved.
//
// Written by Anthony Lee <anthony_lee@asus.com.tw>
//
include("___defines___.php");
include("___defines2___.php");

$oid_enquiry_cache[EMPTY_OID] = '';

function acquire_single_value_with_cache ($ip_addr, $community, $oid, $value_type)
{
    global $oid_enquiry_cache;

    if (!empty($oid_enquiry_cache[$oid]))
        return $oid_enquiry_cache[$oid];
    $acq = acquire_single_value($ip_addr, $community, $oid, $value_type);
    $oid_enquiry_cache[$oid] = $acq;
    return $acq;
}

$summary_info_load = $HTTP_SESSION_VARS["summary_info_load"];
$snmp_source_ip_address = $HTTP_SESSION_VARS["snmp_source_ip_address"];
$snmp_source_community = $HTTP_SESSION_VARS["snmp_source_community"];
$system_model_identify_oid = $HTTP_SESSION_VARS['system_model_identify_oid'];
$static_values = $HTTP_SESSION_VARS['static_values'];

if ((int)$summary_info_load == 0) {

    if ($GLOBALS["dummy_snmp"] == 0)
        $system_model_acq = acquire_single_value_with_cache($snmp_source_ip_address, $snmp_source_community, $system_model_identify_oid, OID_VALUE_INTEGER);
    else
        $system_model_acq = $GLOBALS["dummy_backplane_id"];

    $summary_category_buffer = $HTTP_SESSION_VARS["summary_category_buffer"];
    if (!empty($summary_category_buffer)) {
        foreach ($summary_category_buffer as $buffer) {
            list($oid, $name, $value_type, $attribute, $description) = explode(',', $buffer);
            $summary_category[$oid] = $name;
            $summary_category_value_type[$oid] = $value_type;
            $summary_category_attribute[$oid] = $attribute;
            $summary_category_description[$oid] = stripcslashes($description);
        }
        session_unregister('summary_category_buffer');
        unset($summary_category_buffer);
        session_register('summary_category');
        session_register('summary_category_value_type');
        session_register('summary_category_attribute');
        session_register('summary_category_description');
    }

    $summary_view_buffer = $HTTP_SESSION_VARS["summary_view_buffer"];
    if (!empty($summary_view_buffer)) {
        foreach ($summary_view_buffer as $buffer) {
            list($value, $model_id, $mapfile) = explode(',', $buffer);
            $summary_view_ini_files[$value] = $mapfile;
        }
        session_unregister('summary_view_buffer');
        unset($summary_view_buffer);
    }

    $rtchart_buffers = $HTTP_SESSION_VARS["rtchart_buffers"];

    if (!empty($summary_view_ini_files[$system_model_acq])) {
        $scan_comment = false;
        $secflags[VIEWINIFILE_INIT]                     = false;
        $secflags[VIEWINIFILE_TOP_VIEW]                 = false;
        $secflags[VIEWINIFILE_REAR_VIEW]                = false;
        $secflags[VIEWINIFILE_FRONT_VIEW]               = false;
        $secflags[VIEWINIFILE_TOP_VIEW_IMAGEMAP]        = false;
        $secflags[VIEWINIFILE_REAR_VIEW_IMAGEMAP]       = false;
        $secflags[VIEWINIFILE_FRONT_VIEW_IMAGEMAP]      = false;
        $secflags[VIEWINIFILE_INFO_TITLE]               = false;
        $secflags[VIEWINIFILE_INFO_OID_STRING]          = false;
        $secflags[VIEWINIFILE_COMPOSITE_INFO_IMAGE]     = false;
        $secflags[VIEWINIFILE_OID_REFRESH]              = false;
        $secflags[VIEWINIFILE_VIEW_ALARM]               = false;
        $secflags[VIEWINIFILE_VIEW_ALARM_INFO]          = false;
        $secflags[VIEWINIFILE_INFO_ALARM]               = false;
        $secflags[VIEWINIFILE_INFO_ALARM_ANIMATION]     = false;
        $secflags[VIEWINIFILE_RT_CHART]                 = false;
        $secflags[VIEWINIFILE_STATIC_VALUE]             = false;
        $secflags[VIEWINIFILE_PLATFORM_IMAGES]          = false;
        $secflags[VIEWINIFILE_PLATFORM_IMAGES_ALARM]    = false;
        $secflags[VIEWINIFILE_PLATFORM_IMAGES_ALARM_ANIMATION] = false;

        $secflags[VIEWINIFILE_MODIFY_SECONDARY_OID_SEQUENCE] = false;

        $fp = @fopen($summary_view_ini_files[$system_model_acq], "r");
        if ($fp !== false) {
            while (!@feof($fp)) {
                $buffer = chop(@fgets($fp, 4096));

                if (!strcmp($buffer, INIFILE_COMMENT_BEGIN)) {
                    $scan_comment = true;
                    continue;
                }
                if (!strcmp($buffer, INIFILE_COMMENT_END)) {
                    $scan_comment = false;
                    continue;
                }

                if ($scan_comment)
                    continue;

                if (!strncmp($buffer, INIFILE_COMMENT_SINGLE_LINE, strlen(INIFILE_COMMENT_SINGLE_LINE)))
                    continue;

                if (strpos($buffer, "[") === 0) {
                    if (in_array($buffer, array_keys($secflags))) {
                        foreach ($secflags as $id => $var)
                            $secflags[$id] = false;
                        $secflags[$buffer] = true;
                        continue;
                    }
                }

                if (strlen($buffer) > 1 && strpos($buffer, "[") === false) {
                    if ($secflags[VIEWINIFILE_INIT]) {
                        list($key, $value) = explode('=', $buffer);
                        $GLOBALS[$key] = $value;
                        ${$key} = stripcslashes($value);
                        session_register($key);
                        continue;
                    }

                    if ($secflags[VIEWINIFILE_TOP_VIEW]) {
                        list($var_name, $value) = explode('=', $buffer);
                        $summary_top_view[$var_name] = stripcslashes($value);
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_REAR_VIEW]) {
                        list($var_name, $value) = explode('=', $buffer);
                        $summary_rear_view[$var_name] = stripcslashes($value);
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_FRONT_VIEW]) {
                        list($var_name, $value) = explode('=', $buffer);
                        $summary_front_view[$var_name] = stripcslashes($value);
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_TOP_VIEW_IMAGEMAP]) {
                        list($var_name, $value) = explode('=', $buffer);
                        $summary_top_view_imagemap[$var_name] = $value;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_REAR_VIEW_IMAGEMAP]) {
                        list($var_name, $value) = explode('=', $buffer);
                        $summary_rear_view_imagemap[$var_name] = $value;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_FRONT_VIEW_IMAGEMAP]) {
                        list($var_name, $value) = explode('=', $buffer);
                        $summary_front_view_imagemap[$var_name] = $value;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_INFO_TITLE]) {
                        list($var_name, $value) = explode('=', $buffer);
                        $summary_view_info_title[$var_name] = stripcslashes($value);
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_INFO_OID_STRING]) {
                        list($info_title_id, $value_type_description) = explode('=', $buffer);
                        list($info_title, $id) = explode(',', $info_title_id);
                        $array = "info_oid_string_{$info_title}";
                        $summary_view_info_oid_string[$array] = $array;
                        ${$array}[$id] = stripcslashes($value_type_description);
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_COMPOSITE_INFO_IMAGE]) {
                        list($comp_info_image_title, $item) = explode('$', $buffer);
                        list($title, $id) = explode(',', $comp_info_image_title);
                        $array = "comp_info_image_{$title}";
                        $summary_view_composite_info_image[$array] = $array;
                        ${$array}[$id] = $item;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_OID_REFRESH]) {
                        $summary_view_oid_refresh[] = $buffer;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_VIEW_ALARM]) {
                        list($view_alarm, $css_pos) = explode('=', $buffer);
                        list($view_name, $alarm_name, $alarm_type) = explode(',', $view_alarm);
                        $array = "view_alarm_{$view_name}";
                        $summary_view_view_alarm[$array] = $array;
                        ${$array}["{$alarm_name},{$alarm_type}"] = $css_pos;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_VIEW_ALARM_INFO]) {
                        list($view_name, $alarm_name, $view_info) = explode(',', $buffer);
                        $array = "view_alarm_info_{$view_name}";
                        $summary_view_view_alarm_info[$array] = $array;
                        ${$array}["{$alarm_name}"] = $view_info;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_INFO_ALARM]) {
                        list($info_alarm, $css_pos) = explode('=', $buffer);
                        list($info_name, $alarm_oid) = explode(',', $info_alarm);
                        $array = "info_alarm_{$info_name}";
                        $summary_view_info_alarm[$array] = $array;
                        ${$array}[$alarm_oid] = $css_pos;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_INFO_ALARM_ANIMATION]) {
                        list($ani_alarm, $ani_img) = explode('=', $buffer);
                        list($ani_name, $ani_oid) = explode(',', $ani_alarm);
                        $array = "info_alarm_ani_{$ani_name}";
                        $summary_view_info_alarm_ani[$array] = $array;
                        ${$array}[$ani_oid] = $ani_img;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_RT_CHART]) {
                        list($sensor_oid_cat, $chart_prop) = explode('=', $buffer);
                        list($sen_oid, $sen_cat) = explode(',', $sensor_oid_cat);
                        $rtchart_property[$sen_oid] = stripcslashes($chart_prop);
                        $array = "rtchart_category_{$sen_cat}";
                        $rtchart_category[$sen_cat] = $array;
                        ${$array}[$sen_oid] = $sen_oid;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_STATIC_VALUE]) {
                        list($oid, $value) = explode('=', $buffer);
                        $static_values[$oid] = $value;
                    }
                    if ($secflags[VIEWINIFILE_PLATFORM_IMAGES]) {
                        list($cat_idx, $img) = explode('=', $buffer);
                        list($cat, $idx) = explode(',', $cat_idx);
                        $array = "platform_image_{$cat}";
                        $platform_image[$cat] = $array;
                        ${$array}[$idx] = $img;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_PLATFORM_IMAGES_ALARM]) {
                        list($img_alarm, $css_pos) = explode('=', $buffer);
                        list($cat, $alarm_oid) = explode(',', $img_alarm);
                        $array = "platform_image_alarm_{$cat}";
                        $platform_image_alarm[$cat] = $array;
                        ${$array}[$alarm_oid] = $css_pos;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_PLATFORM_IMAGES_ALARM_ANIMATION]) {
                        list($ani_alarm, $ani_img) = explode('=', $buffer);
                        list($cat, $ani_oid) = explode(',', $ani_alarm);
                        $array = "platform_image_alarm_ani_{$cat}";
                        $platform_image_alarm_ani[$array] = $array;
                        ${$array}[$ani_oid] = $ani_img;
                        continue;
                    }
                    if ($secflags[VIEWINIFILE_MODIFY_SECONDARY_OID_SEQUENCE]) {
                        list($secc, $oid, $act) = explode(',', $buffer);
                        if (!empty(${$secc}[$oid])) {
                            if (!strcmp($act, OID_SEQ_MODIFY_ACTION_MOVE_TO_TAIL)) {
                                $attr = ${$secc}[$oid];
                                remove_key(&${$secc}, $oid);
                                ${$secc}[$oid] = $attr;
                            }
                        }
                        $array = "oid_seq_modify_actions_{$secc}";
                        $oid_seq_modify_actions[$secc] = $array;
                        ${$array}[$oid] = $act;
                        continue;
                    }
                }
            }
            @fclose($fp);

            if (!empty($summary_top_view))
                session_register('summary_top_view');
            if (!empty($summary_rear_view))
                session_register('summary_rear_view');
            if (!empty($summary_front_view))
                session_register('summary_front_view');
            if (!empty($summary_top_view_imagemap))
                session_register('summary_top_view_imagemap');
            if (!empty($summary_rear_view_imagemap))
                session_register('summary_rear_view_imagemap');
            if (!empty($summary_front_view_imagemap))
                session_register('summary_front_view_imagemap');
            if (!empty($summary_view_info_title))
                session_register('summary_view_info_title');
            if (!empty($summary_view_info_oid_string)) {
                foreach ($summary_view_info_oid_string as $array) {
                    session_register($array);
                }
            }

            if (!empty($summary_view_oid_refresh))
                session_register('summary_view_oid_refresh');

            if (!empty($summary_view_composite_info_image)) {
                foreach ($summary_view_composite_info_image as $array) {
                    session_register($array);
                }
            }
            if (!empty($summary_view_view_alarm)) {
                foreach ($summary_view_view_alarm as $array) {
                    session_register($array);
                }
            }
            if (!empty($summary_view_view_alarm_info)) {
                foreach ($summary_view_view_alarm_info as $array) {
                    session_register($array);
                }
            }
            if (!empty($summary_view_info_alarm)) {
                foreach ($summary_view_info_alarm as $array) {
                    session_register($array);
                }
            }
            if (!empty($summary_view_info_alarm_ani)) {
                foreach ($summary_view_info_alarm_ani as $array) {
                    session_register($array);
                }
            }
            if (!empty($static_values)) {
                session_register('static_values');
            }
            if (!empty($platform_image)) {
                foreach ($platform_image as $array) {
                    session_register($array);
                }
            }
            if (!empty($platform_image_alarm)) {
                foreach ($platform_image_alarm as $array) {
                    session_register($array);
                }
            }
            if (!empty($platform_image_alarm_ani)) {
                foreach ($platform_image_alarm_ani as $array) {
                    session_register($array);
                }
            }
            if (!empty($oid_seq_modify_actions)) {
                foreach ($oid_seq_modify_actions as $array) {
                    session_register($array);
                }
            }
        }
    }

    if (!empty($rtchart_buffers)) {
        foreach ($rtchart_buffers as $buffer) {
            list($sensor_oid_cat, $chart_prop) = explode('=', $buffer);
            list($sen_oid, $sen_cat) = explode(',', $sensor_oid_cat);
            $rtchart_property[$sen_oid] = stripcslashes($chart_prop);
            $array = "rtchart_category_{$sen_cat}";
            $rtchart_category[$sen_cat] = $array;
            ${$array}[$sen_oid] = $sen_oid;
        }
        session_unregister('rtchart_buffers');
        unset($rtchart_buffers);
        session_register('rtchart_property');
        session_register('rtchart_category');
        foreach ($rtchart_category as $array) {
            session_register($array);
        }
    }
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html>
<head>
<?php echo $HTTP_SESSION_VARS['cntype']; ?>
</head>
<script language=javascript>
var ok = 'ok';
</script>
<body BGCOLOR="#CEE7FF" marginwidth="0" marginheight="0" leftmargin="0" topmargin="0">
</body>
</html>